/****************************************************************
**
** Definition of CIGLWidget class 
**
****************************************************************/

#ifndef CIGLWIDGET_H
#define CIGLWIDGET_H

#include <gl/glew.h>

#include <qgl.h>
#include <CI/CITrackball.h>
#include <MMSG.h>


class CIGLWidget : public  QGLWidget 
{ 
	Q_OBJECT	
public:
  CIGLWidget( QWidget *parent=0, const char *name=0 );
  void initializeGL();
  void resizeGL( int w, int h );
  void paintGL();
	vcg::MMSG *sg;
	bool editing;
public slots:
	void setEditing(bool);
protected:
	void mousePressEvent(QMouseEvent*e);
	void mouseMoveEvent(QMouseEvent*e);
	void mouseReleaseEvent(QMouseEvent*e);
	void wheelEvent(QWheelEvent*e); 

private:
	vcg::Matrix44f rot;
	vcg::CITrackball tb;
	vcg::Point2i pickPos;
	float zoomFactor;
	bool rubberBanding;
	vcg::Point2i rbStart;
};

#endif
